{
    "$graph": [
        {
            "class": "Workflow",
            "hints": [
                {
                    "class": "ResourceRequirement",
                    "coresMax": 1,
                    "ramMax": 2000
                }
            ],
            "inputs": [
                {
                    "doc": ".fasta.gz",
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#VDJ_Annotate_Reads.cwl/Cdr3QueryFasta"
                },
                {
                    "type": {
                        "type": "enum",
                        "symbols": [
                            "#VDJ_Annotate_Reads.cwl/vdjType/Ig",
                            "#VDJ_Annotate_Reads.cwl/vdjType/TCR"
                        ]
                    },
                    "id": "#VDJ_Annotate_Reads.cwl/vdjType"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "enum",
                            "symbols": [
                                "file:///Users/aronlau/PycharmProjects/mist/dist/local_Targeted/VDJ_Version.enum#human",
                                "file:///Users/aronlau/PycharmProjects/mist/dist/local_Targeted/VDJ_Version.enum#humanBCR",
                                "file:///Users/aronlau/PycharmProjects/mist/dist/local_Targeted/VDJ_Version.enum#humanTCR",
                                "file:///Users/aronlau/PycharmProjects/mist/dist/local_Targeted/VDJ_Version.enum#mouse",
                                "file:///Users/aronlau/PycharmProjects/mist/dist/local_Targeted/VDJ_Version.enum#mouseBCR",
                                "file:///Users/aronlau/PycharmProjects/mist/dist/local_Targeted/VDJ_Version.enum#mouseTCR"
                            ]
                        }
                    ],
                    "id": "#VDJ_Annotate_Reads.cwl/vdjVersion"
                }
            ],
            "steps": [
                {
                    "id": "#VDJ_Annotate_Reads.cwl/CallCdr3",
                    "run": {
                        "id": "#VDJ_Annotate_Reads.cwl/CallCdr3/CallCdr3Inner",
                        "cwlVersion": "v1.0",
                        "class": "CommandLineTool",
                        "requirements": [
                            {
                                "dockerPull": "bdgenomics/rhapsody:1.9-beta",
                                "class": "DockerRequirement"
                            },
                            {
                                "class": "InlineJavascriptRequirement"
                            },
                            {
                                "class": "ShellCommandRequirement"
                            }
                        ],
                        "baseCommand": [
                            "mist_pyirWrapper.py"
                        ],
                        "inputs": [
                            {
                                "type": [
                                    "null",
                                    "File"
                                ],
                                "id": "#VDJ_Annotate_Reads.cwl/CallCdr3/CallCdr3Inner/Cdr3QueryFasta"
                            },
                            {
                                "type": {
                                    "type": "enum",
                                    "symbols": [
                                        "#VDJ_Annotate_Reads.cwl/CallCdr3/CallCdr3Inner/vdjType/Ig",
                                        "#VDJ_Annotate_Reads.cwl/CallCdr3/CallCdr3Inner/vdjType/TCR"
                                    ]
                                },
                                "id": "#VDJ_Annotate_Reads.cwl/CallCdr3/CallCdr3Inner/vdjType"
                            },
                            {
                                "type": [
                                    "null",
                                    {
                                        "type": "enum",
                                        "symbols": [
                                            "file:///Users/aronlau/PycharmProjects/mist/dist/local_Targeted/VDJ_Version.enum#human",
                                            "file:///Users/aronlau/PycharmProjects/mist/dist/local_Targeted/VDJ_Version.enum#humanBCR",
                                            "file:///Users/aronlau/PycharmProjects/mist/dist/local_Targeted/VDJ_Version.enum#humanTCR",
                                            "file:///Users/aronlau/PycharmProjects/mist/dist/local_Targeted/VDJ_Version.enum#mouse",
                                            "file:///Users/aronlau/PycharmProjects/mist/dist/local_Targeted/VDJ_Version.enum#mouseBCR",
                                            "file:///Users/aronlau/PycharmProjects/mist/dist/local_Targeted/VDJ_Version.enum#mouseTCR"
                                        ]
                                    }
                                ],
                                "id": "#VDJ_Annotate_Reads.cwl/CallCdr3/CallCdr3Inner/vdjVersion"
                            }
                        ],
                        "arguments": [
                            {
                                "prefix": "-r",
                                "valueFrom": "$(inputs.vdjType)"
                            },
                            {
                                "prefix": "--database",
                                "valueFrom": "/mist/pyir_data"
                            },
                            {
                                "prefix": "-f",
                                "valueFrom": "json"
                            },
                            {
                                "prefix": "-m",
                                "valueFrom": "1"
                            },
                            {
                                "prefix": "-s",
                                "valueFrom": "${\n  if (!inputs.vdjVersion) {\n    return(\"~/deliberatelyNotADirectoryToInduceFailure\");\n  } else if (inputs.vdjVersion === \"human\" || inputs.vdjVersion === \"humanBCR\" || inputs.vdjVersion === \"humanTCR\"){\n    return(\"human\");\n  } else if (inputs.vdjVersion === \"mouse\" || inputs.vdjVersion === \"mouseBCR\" || inputs.vdjVersion === \"mouseTCR\"){\n    return(\"mouse\");\n  } else {\n    throw(\"Unknown VDJ version\");\n  }\n}"
                            },
                            {
                                "prefix": "-o",
                                "valueFrom": "${\n  if(inputs.Cdr3QueryFasta){\n    return(inputs.Cdr3QueryFasta.nameroot.split(\".\")[0]);\n  } else {\n    return(\"NA\");\n  }\n}"
                            },
                            {
                                "prefix": "-winput",
                                "valueFrom": "${\n  if (!inputs.vdjType) {\n    return(\"~/deliberatelyNotAQueryFastaToInduceFailure.fasta\");\n  } else {\n    return(inputs.Cdr3QueryFasta);\n  }\n}"
                            },
                            {
                                "valueFrom": "${\n  if (!inputs.vdjVersion && !inputs.Cdr3QueryFasta) {\n    return(\"&> /dev/null || true ; echo 'Since this is not a VDJ run, we will skip this node...'\");\n  } else if (!inputs.vdjVersion && inputs.Cdr3QueryFasta){\n    throw(\"VDJ disabled but CDR3 calling FASTA specified!\");\n  } else if (inputs.vdjVersion && !inputs.Cdr3QueryFasta) {\n    return(\"&> /dev/null || true ; echo 'VDJ enabled, but no query sequence specified. Assuming none were capture in AnnotateReads!'\");\n  } else if (inputs.vdjVersion && inputs.Cdr3QueryFasta) {\n    return(\"\");\n  }\n}",
                                "shellQuote": false
                            }
                        ],
                        "outputs": [
                            {
                                "type": [
                                    "null",
                                    "File"
                                ],
                                "outputBinding": {
                                    "glob": "*.json.gz",
                                    "outputEval": "${\n  if (inputs.vdjVersion && inputs.Cdr3QueryFasta && self.size == 0) {\n    throw(\"No outputs from PyIR detected!\");\n  } else {\n    return(self);\n  }\n}"
                                },
                                "id": "#VDJ_Annotate_Reads.cwl/CallCdr3/CallCdr3Inner/Cdr3Call"
                            }
                        ]
                    },
                    "in": [
                        {
                            "source": "#VDJ_Annotate_Reads.cwl/CallConstantRegion/ConstantRegionCall",
                            "id": "#VDJ_Annotate_Reads.cwl/CallCdr3/Cdr3QueryFasta"
                        },
                        {
                            "source": "#VDJ_Annotate_Reads.cwl/vdjType",
                            "id": "#VDJ_Annotate_Reads.cwl/CallCdr3/vdjType"
                        },
                        {
                            "source": "#VDJ_Annotate_Reads.cwl/vdjVersion",
                            "id": "#VDJ_Annotate_Reads.cwl/CallCdr3/vdjVersion"
                        }
                    ],
                    "out": [
                        "#VDJ_Annotate_Reads.cwl/CallCdr3/Cdr3Call"
                    ]
                },
                {
                    "id": "#VDJ_Annotate_Reads.cwl/CallConstantRegion",
                    "run": {
                        "id": "#VDJ_Annotate_Reads.cwl/CallConstantRegion/CallConstantRegionInner",
                        "cwlVersion": "v1.0",
                        "class": "CommandLineTool",
                        "requirements": [
                            {
                                "dockerPull": "bdgenomics/rhapsody:1.9-beta",
                                "class": "DockerRequirement"
                            },
                            {
                                "class": "InlineJavascriptRequirement"
                            },
                            {
                                "class": "ShellCommandRequirement"
                            }
                        ],
                        "baseCommand": [
                            "bowtie2"
                        ],
                        "inputs": [
                            {
                                "type": [
                                    "null",
                                    "File"
                                ],
                                "id": "#VDJ_Annotate_Reads.cwl/CallConstantRegion/CallConstantRegionInner/Cdr3QueryFasta"
                            },
                            {
                                "type": [
                                    "null",
                                    {
                                        "type": "enum",
                                        "symbols": [
                                            "file:///Users/aronlau/PycharmProjects/mist/dist/local_Targeted/VDJ_Version.enum#human",
                                            "file:///Users/aronlau/PycharmProjects/mist/dist/local_Targeted/VDJ_Version.enum#humanBCR",
                                            "file:///Users/aronlau/PycharmProjects/mist/dist/local_Targeted/VDJ_Version.enum#humanTCR",
                                            "file:///Users/aronlau/PycharmProjects/mist/dist/local_Targeted/VDJ_Version.enum#mouse",
                                            "file:///Users/aronlau/PycharmProjects/mist/dist/local_Targeted/VDJ_Version.enum#mouseBCR",
                                            "file:///Users/aronlau/PycharmProjects/mist/dist/local_Targeted/VDJ_Version.enum#mouseTCR"
                                        ]
                                    }
                                ],
                                "id": "#VDJ_Annotate_Reads.cwl/CallConstantRegion/CallConstantRegionInner/vdjVersion"
                            }
                        ],
                        "arguments": [
                            "--quiet",
                            "--no-head",
                            "--local",
                            "-p",
                            "1",
                            "-L",
                            "10",
                            "-N",
                            "1",
                            "--ma",
                            "4",
                            {
                                "prefix": "-f",
                                "valueFrom": "$(inputs.Cdr3QueryFasta)"
                            },
                            {
                                "prefix": "-x",
                                "valueFrom": "${\n  if (!inputs.vdjVersion) {\n    return(\"~/deliberatelyNotADirectoryToInduceFailure\");\n  } else if (inputs.vdjVersion === \"human\" || inputs.vdjVersion === \"humanBCR\" || inputs.vdjVersion === \"humanTCR\"){\n    return(\"/mist/vdj_constant_region_reference_index/humanVDJCidx\");\n  } else if (inputs.vdjVersion === \"mouse\" || inputs.vdjVersion === \"mouseBCR\" || inputs.vdjVersion === \"mouseTCR\"){\n    return(\"/mist/vdj_constant_region_reference_index/mouseVDJCidx\");\n  } else {\n    throw(\"Unknown VDJ version\");\n  }\n}"
                            },
                            {
                                "valueFrom": "|",
                                "shellQuote": false
                            },
                            "awk",
                            {
                                "shellQuote": false,
                                "valueFrom": "${\n  if(inputs.Cdr3QueryFasta) {\n    return(\"\\'{print \\\">\\\" $1 \\\",\\\" $3 \\\"\\\\n\\\" $10 |  \\\" gzip >> \" + inputs.Cdr3QueryFasta.nameroot.split(\".\")[0] + \"_constant_region_called.fasta.gz\\\"}\\'\");\n  } else {\n    return(\"\\'{print \\\">\\\" $1 \\\",\\\" $3 \\\"\\\\n\\\" $10}\\'\");\n  }\n}"
                            },
                            {
                                "valueFrom": "${\n  if (!inputs.vdjVersion && !inputs.Cdr3QueryFasta) {\n    return(\"&> /dev/null || true ; echo 'Since this is not a VDJ run, we will skip this node...'\");\n  } else if (!inputs.vdjVersion && inputs.Cdr3QueryFasta){\n    throw(\"VDJ disabled but CDR3 calling FASTA specified!\");\n  } else if (inputs.vdjVersion && !inputs.Cdr3QueryFasta) {\n    return(\"&> /dev/null || true ; echo 'VDJ enabled, but no query sequence specified. Assuming none were capture in AnnotateReads!'\");\n  } else if (inputs.vdjVersion && inputs.Cdr3QueryFasta) {\n    return(\"\");\n  }\n}",
                                "shellQuote": false
                            }
                        ],
                        "outputs": [
                            {
                                "type": [
                                    "null",
                                    "File"
                                ],
                                "outputBinding": {
                                    "glob": "*_constant_region_called.fasta.gz",
                                    "outputEval": "${\n  if (!inputs.vdjVersion) {\n    return(null);\n  } else {\n    return(self);\n  }\n}"
                                },
                                "id": "#VDJ_Annotate_Reads.cwl/CallConstantRegion/CallConstantRegionInner/ConstantRegionCall"
                            }
                        ]
                    },
                    "in": [
                        {
                            "source": "#VDJ_Annotate_Reads.cwl/Cdr3QueryFasta",
                            "id": "#VDJ_Annotate_Reads.cwl/CallConstantRegion/Cdr3QueryFasta"
                        },
                        {
                            "source": "#VDJ_Annotate_Reads.cwl/vdjVersion",
                            "id": "#VDJ_Annotate_Reads.cwl/CallConstantRegion/vdjVersion"
                        }
                    ],
                    "out": [
                        "#VDJ_Annotate_Reads.cwl/CallConstantRegion/ConstantRegionCall"
                    ]
                },
                {
                    "run": {
                        "id": "#VDJ_Annotate_Reads.cwl/PrunePyIR/PrunePyIRInner",
                        "cwlVersion": "v1.0",
                        "class": "CommandLineTool",
                        "requirements": [
                            {
                                "dockerPull": "bdgenomics/rhapsody:1.9-beta",
                                "class": "DockerRequirement"
                            }
                        ],
                        "baseCommand": [
                            "mist_prune_pyir.py"
                        ],
                        "inputs": [
                            {
                                "type": [
                                    "null",
                                    "File"
                                ],
                                "inputBinding": {
                                    "position": 0
                                },
                                "id": "#VDJ_Annotate_Reads.cwl/PrunePyIR/PrunePyIRInner/PyIROutput"
                            }
                        ],
                        "outputs": [
                            {
                                "type": [
                                    "null",
                                    "File"
                                ],
                                "outputBinding": {
                                    "glob": "*_pruned.csv.gz"
                                },
                                "id": "#VDJ_Annotate_Reads.cwl/PrunePyIR/PrunePyIRInner/PrunedPyIROutput"
                            }
                        ]
                    },
                    "in": [
                        {
                            "source": "#VDJ_Annotate_Reads.cwl/CallCdr3/Cdr3Call",
                            "id": "#VDJ_Annotate_Reads.cwl/PrunePyIR/PyIROutput"
                        }
                    ],
                    "out": [
                        "#VDJ_Annotate_Reads.cwl/PrunePyIR/PrunedPyIROutput"
                    ],
                    "id": "#VDJ_Annotate_Reads.cwl/PrunePyIR"
                }
            ],
            "id": "#VDJ_Annotate_Reads.cwl",
            "outputs": [
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputSource": "#VDJ_Annotate_Reads.cwl/PrunePyIR/PrunedPyIROutput",
                    "id": "#VDJ_Annotate_Reads.cwl/Cdr3Call"
                }
            ]
        },
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        {
                            "type": "enum",
                            "symbols": [
                                "file:///Users/aronlau/PycharmProjects/mist/dist/local_Targeted/VDJ_Version.enum#human",
                                "file:///Users/aronlau/PycharmProjects/mist/dist/local_Targeted/VDJ_Version.enum#humanBCR",
                                "file:///Users/aronlau/PycharmProjects/mist/dist/local_Targeted/VDJ_Version.enum#humanTCR",
                                "file:///Users/aronlau/PycharmProjects/mist/dist/local_Targeted/VDJ_Version.enum#mouse",
                                "file:///Users/aronlau/PycharmProjects/mist/dist/local_Targeted/VDJ_Version.enum#mouseBCR",
                                "file:///Users/aronlau/PycharmProjects/mist/dist/local_Targeted/VDJ_Version.enum#mouseTCR"
                            ]
                        }
                    ],
                    "id": "#main/VDJ_Version"
                },
                {
                    "type": "int",
                    "id": "#main/numFiles"
                },
                {
                    "doc": ".fasta.gz",
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#main/validReadsTcr"
                }
            ],
            "outputs": [
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputSource": "#main/CallCdr3ForTcrs/Cdr3Call",
                    "id": "#main/tcrCalls"
                }
            ],
            "steps": [
                {
                    "hints": [
                        {
                            "class": "ResourceRequirement",
                            "coresMin": "$(inputs.numFiles)"
                        }
                    ],
                    "run": "#VDJ_Annotate_Reads.cwl",
                    "in": [
                        {
                            "source": "#main/validReadsTcr",
                            "id": "#main/CallCdr3ForTcrs/Cdr3QueryFasta"
                        },
                        {
                            "valueFrom": "TCR",
                            "id": "#main/CallCdr3ForTcrs/vdjType"
                        },
                        {
                            "source": "#main/VDJ_Version",
                            "id": "#main/CallCdr3ForTcrs/vdjVersion"
                        }
                    ],
                    "out": [
                        "#main/CallCdr3ForTcrs/Cdr3Call"
                    ],
                    "id": "#main/CallCdr3ForTcrs"
                }
            ],
            "id": "#main"
        }
    ],
    "cwlVersion": "v1.0",
    "$namespaces": {
        "sbg": "https://sevenbridges.com#",
        "arv": "http://arvados.org/cwl#"
    }
}
